﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics;
using Infragistics.Controls.Charts;

namespace StackedColumnSeriesHelp
{
    //http://www.infragistics.com/community/forums/t/64311.aspx?PageIndex=1
    public partial class MainWindow : Window
    {
        private TestEmissionsCollection data;
        public MainWindow()
        {
            InitializeComponent();

            data = new TestEmissionsCollection();

            GroupBy grouped = new GroupBy();
            grouped.ItemsSource = data;
            grouped.GroupMemberPath = "Date";
            grouped.KeyMemberPath = "Installation";
            grouped.ValueMemberPath = "Emission";

//            CategoryXAxis xAxis = new CategoryXAxis();
            CategoryDateTimeXAxis xAxis = new CategoryDateTimeXAxis();
            xAxis.DateTimeMemberPath = "Date";
            xAxis.Label = "{Date}";
            xAxis.ItemsSource = grouped;
            NumericYAxis yAxis = new NumericYAxis();

            StackedColumnSeries stack = new StackedColumnSeries();
            stack.ItemsSource = grouped;
            stack.XAxis = xAxis;
            stack.YAxis = yAxis;
            stack.AutoGenerateSeries = true;

            theChart.Axes.Add(xAxis);
            theChart.Axes.Add(yAxis);
            theChart.Series.Add(stack);
        }
    }

    public class TestEmissionsCollection
            : ObservableCollection<InstalationEmissionDateInformation>
    {
        public TestEmissionsCollection()
        {
            Add(new InstalationEmissionDateInformation("A", 5, new DateTime(2012, 1, 1, 0, 0, 0), 1));
            Add(new InstalationEmissionDateInformation("B", 2, new DateTime(2012, 1, 1, 0, 0, 0), 1));
            Add(new InstalationEmissionDateInformation("C", 7, new DateTime(2012, 1, 1, 0, 0, 0), 1));
            Add(new InstalationEmissionDateInformation("A", 6, new DateTime(2012, 1, 2, 0, 0, 0), 1));
            Add(new InstalationEmissionDateInformation("B", 3, new DateTime(2012, 1, 2, 0, 0, 0), 1));
            Add(new InstalationEmissionDateInformation("C", 8, new DateTime(2012, 1, 2, 0, 0, 0), 1));
            Add(new InstalationEmissionDateInformation("A", 6, new DateTime(2012, 1, 3, 0, 0, 0), 1));
            Add(new InstalationEmissionDateInformation("B", 3, new DateTime(2012, 1, 3, 0, 0, 0), 1));
            Add(new InstalationEmissionDateInformation("C", 6, new DateTime(2012, 1, 3, 0, 0, 0), 1));
            Add(new InstalationEmissionDateInformation("A", 4, new DateTime(2012, 1, 4, 0, 0, 0), 1));
            Add(new InstalationEmissionDateInformation("B", 3, new DateTime(2012, 1, 4, 0, 0, 0), 1));
            Add(new InstalationEmissionDateInformation("C", 7, new DateTime(2012, 1, 4, 0, 0, 0), 1));
        }
    }

    public class InstalationEmissionDateInformation
    {
        public string Installation { get; set; }
        public Decimal Emission { get; set; }
        public DateTime Date { get; set; }
        public Decimal Assignation { get; set; }

        public InstalationEmissionDateInformation(
            string installation,
            Decimal emission,
            DateTime date,
            Decimal assignation)
        {
            Installation = installation;
            Emission = emission;
            Date = date;
            Assignation = assignation;
        }
    }
}
